Index: main/features.c
===================================================================
--- main/features.c	(revision 307273)
+++ main/features.c	(working copy)
@@ -640,6 +640,18 @@
 	return 0;
 }
 
+static int find_parkinglot_by_name_cb(void *obj, void *args, int flags)
+{
+	struct ast_parkinglot *parkinglot = obj;
+	const char *parkname = args;
+
+	if (!strcmp(parkinglot->name, parkname)) {
+		return CMP_MATCH | CMP_STOP;
+	}
+
+	return 0;
+}
+
 int ast_parking_ext_valid(const char *exten_str, struct ast_channel *chan, const char *context)
 {
 	struct ast_exten *exten;
@@ -4390,12 +4402,19 @@
 	int park = 0;
 	struct ast_bridge_config config;
 	struct ast_parkinglot *parkinglot;
+	char* atpos = NULL;
 
 	if (data) {
 		park = atoi((char *) data);
+		atpos = strchr(data, (int)'@');
 	}
 
-	parkinglot = ao2_callback(parkinglots, 0, find_parkinglot_by_position_cb, (void *) &park);
+	if (atpos) {
+		parkinglot = ao2_callback(parkinglots, 0, find_parkinglot_by_name_cb, (void *) (atpos+1));
+	} else {
+		parkinglot = ao2_callback(parkinglots, 0, find_parkinglot_by_position_cb, (void *) &park);
+	}
+
 	if (!parkinglot)
 		parkinglot = default_parkinglot;
 
@@ -4418,11 +4437,11 @@
 		con = ast_context_find(parkinglot->parking_con);
 		if (con) {
 			if (ast_context_remove_extension2(con, pu->parkingexten, 1, NULL, 0))
-				ast_log(LOG_WARNING, "Whoa, failed to remove the extension!\n");
+				ast_log(LOG_WARNING, "Failed to remove the extension!\n");
 			else
 				notify_metermaids(pu->parkingexten, parkinglot->parking_con, AST_DEVICE_NOT_INUSE);
 		} else
-			ast_log(LOG_WARNING, "Whoa, no parking context?\n");
+			ast_log(LOG_WARNING, "No parking context?\n");
 
 		ast_cel_report_event(pu->chan, AST_CEL_PARK_END, NULL, "UnParkedCall", chan);
 		ast_manager_event(pu->chan, EVENT_FLAG_CALL, "UnParkedCall",
